#include <vector>
#include <iostream>
#include <set>
#include <unordered_set>

using namespace std;

int main() {
    int n, l;
    cin >> n >> l;
    vector<int> A(n);

    for (int i = 0; i < n; i++) {
        cin >> A[i];
    }

    int possible_x_count = 0;
    int all_bits = (1 << l);

    for (int x = 0; x < all_bits; x++) {
        unordered_multiset<int> transformed_set;
        for (int a : A) {
            transformed_set.insert(a ^ x);
        }
        if (unordered_multiset<int>(A.begin(), A.end()) == transformed_set) {
            possible_x_count++;
        }
    }

    cout << (1 << l) / possible_x_count << endl;
    return 0;
}

