#include "testlib.h"
#include<bits/stdc++.h>
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

int main(int argc, char **argv){
	registerGen(argc, argv, 1);
	int maxn = opt<int>(1), maxl = opt<int>(2), ans = opt<int>(3);
	assert((1 << ans) <= maxn);
	assert(ans <= maxl);
	bool duplicate = opt<bool>("duplicate");
	bool special = opt<bool>("special");
	vector<int> basis;
	while(basis.size() < ans){
		int x = rnd.next(0, (1 << maxl) - 1);
		for(auto &y : basis) x = min(x, x ^ y);
		if(x) basis.push_back(x);
	}
	vector<int> v;
	set<int> S;
	set<int> used_reps;
	while(v.size() + (1 << (int)basis.size()) <= (90 * maxn / 100)){
		int rng = rnd.next(0, (1 << maxl) - 1);
		vector<int> cands;
		for(int mask = 0; mask < (1 << (int)basis.size()); mask ++){
			int xrng = rng;
			for(int i = 0; i < basis.size(); i ++){
				if((mask >> i) & 1){
					xrng ^= basis[i];
				}
			}
			cands.push_back(xrng);
		}
		bool ok = true;
		for(auto x : cands){
			ok &= (S.count(x) == false); 
		}
		if(!ok && !duplicate) continue;
		if(duplicate){
			int reps = (maxn - v.size()) / (1 << (int)basis.size());
			if((1 << maxl) > maxn){
				if(special) reps = sqrt(reps);
				while(true){
					reps = rnd.next(1, reps);
					if(!used_reps.count(reps) || rnd.next(1, 100) <= 60){
						used_reps.insert(reps);
						break;
					}
				}
			}
			while(reps --) v.insert(v.end(), all(cands));
		}
		else v.insert(v.end(), all(cands));
		for(auto x : cands) S.insert(x);
	}
	cout << v.size() << " " << maxl << endl;
	for(auto x : v){
		cout << x << " ";
	} cout << endl;

}
